{

  JAM_run_con.spin

  Console. Written in spin, only for testing purposes.

}

CON
  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000
'   keyPins   = (Hydra & 13) | ((Demo | Proto) & 26)
OBJ
  'My GFX driver
  rast : "JAM_run_rast_005"
  md1 : "JAM_run_md1_005"
  font : "JAM_run_font_005"
  
  'Michael Green's ComboKeyboard driver  
  kbd : "comboKeyboard"
                          
VAR
LONG CursorY
LONG CursorX

BYTE Color
BYTE DefaultColor
BYTE FirstRow
BYTE LastRow

LONG ColBufferSPTR
LONG TxtBufferSPTR

BYTE InputBuffer[37]
PUB TestStuffs
  Init(24, 13)

  PrintDec(-10,3)
  PrintHex(-$FA91, 5)  
  waitcnt(clkfreq + cnt)
  repeat
    PrintLn(Prompt(string("C:/>")))
PUB Init(NTSCBasePin, kbdGroup)
  rast.Start(NTSCBasePin)    
  rast.SetMode(0, md1.GetModePar)

  kbd.start(kbdGroup)

  md1.ConfigureCursor0(constant(4+128))
  ColBufferSPTR := md1.GetCol
  TxtBufferSPTR := md1.GetTxt
  DefaultColor := $05
  Color := DefaultColor
  FirstRow := 0
  LastRow := 23
  Cls
PUB Cls | i    
  repeat i from 0 to constant(36*24-1)
    BYTE[ColBufferSPTR+i] := $05
    BYTE[TxtBufferSPTR+i] := 32
  md1.SetFirstRow(0)
  CursorY := 0
  CursorX := 0
  MoveCursor(CursorY, CursorX)
PUB SetColor(bg, fg)
  Color := bg<<4+fg
PUB RestoreColor
  Color := DefaultColor
PUB SetDefaultColor(bg, fg)
  DefaultColor := bg<<4+fg
PRI i_ClearLastLine | sptr, colSptr
  sptr := LastRow*36 + TxtBufferSPTR
  colSptr := LastRow*36 + ColBufferSPTR 
  repeat 36
    BYTE[sptr++] := 32
    BYTE[colSptr++] := DefaultColor 
PRI i_ScrollOneRowDown
  FirstRow++
  LastRow++
  if(LastRow > 23)
    LastRow := 0
  if(FirstRow > 23)
    FirstRow := 0
  md1.SetFirstRow(FirstRow)
  i_ClearLastLine
PRI i_SetBlinking(mode)
  md1.ConfigureCursor0(4+(128 & mode))  
PUB MoveCursor(phys_x, phys_y)
  CursorX := phys_x
  CursorY := phys_y
  
  md1.MoveCursor0(CursorX, CursorY)
PUB PrintDec(value, nDigits) | sptr, colSptr
  ''Doesn't print if wouldn't fit to avoid misunderstandings.
  ''Requires nDigits+1 space. (for minus sign)
  if(nDigits+CursorX > 36)
    return  

  sptr := CursorY + FirstRow
  if(sptr > 23)
    sptr -= 24
  sptr*=36
  colSptr := sptr + ColBufferSPTR+CursorX
  sptr += TxtBufferSPTR + CursorX

  
  if(value < 0 and nDigits < 0)
    CursorX++
    BYTE[sptr] := 45
  BYTE[colSptr] := Color
  if(nDigits < 0)
    nDigits := -nDigits
  else
    sptr--
    colSptr--
  sptr += nDigits
  colSptr += nDigits

  ||value 'ABS
  repeat nDigits
    BYTE[sptr--] := value // 10 + 48
    BYTE[colSptr--] := color
    value /= 10
  CursorX += nDigits
  MoveCursor(CursorX,CursorY)
PUB PutChar(c)  | sptr,colSptr
  sptr := CursorY + FirstRow
  if(sptr > 23)
    sptr -= 24
  sptr*=36
  colSptr := sptr + ColBufferSPTR+CursorX
  sptr += TxtBufferSPTR + CursorX
  BYTE[sptr] := c
  BYTE[colSptr] := color
  if(CursorX < 35)
   CursorX++
  MoveCursor(CursorX, CursorY)
PUB PrintHex(value, nDigits) | sptr, temp ,colSptr
  ''Doesn't print if wouldn't fit to avoid misunderstandings.
  ''Requires nDigits+1 space. (for minus sign)
  if(nDigits+CursorX > 36)
    return  

  sptr := CursorY + FirstRow
  if(sptr > 23)
    sptr -= 24
  sptr*=36
  colSptr := sptr + ColBufferSPTR+CursorX
  sptr += TxtBufferSPTR + CursorX

  if(value < 0 and nDigits < 0)
    BYTE[sptr] := 45
    BYTE[colSptr] := color
    CursorX++

  if(nDigits < 0)
    nDigits := -nDigits
  else
    sptr--
    colSptr--
      
  sptr += nDigits
  colSptr+=nDigits
  ||value 'ABS  
  repeat nDigits
    temp := value & $F
    if(temp < 10)
      BYTE[sptr--] := value & $F + 48
    else
      BYTE[sptr--] := value & $F + 55        
    BYTE[colSptr--] := color
    value >>= 4
  CursorX += nDigits
  MoveCursor(CursorX,CursorY)
  
PUB Print(text) | len, sptr, i, colSptr
  ''Prints on cursor location using
  ''current color. Moves cursor, but
  ''never changes line.
  len := strsize(text)  
  if(len+CursorX > 36)
    len := 36 - CursorX
  sptr := CursorY + FirstRow
  if(sptr > 23)
    sptr -= 24
  sptr*=36
  
  colSptr := sptr + ColBufferSPTR + CursorX
  sptr    += TxtBufferSPTR + CursorX

  CursorX += len
  if(CursorX > 35)
    i_SetBlinking(false)
    CursorX := 35
  md1.MoveCursor0(CursorX, CursorY)

  repeat len
    BYTE[sptr++] := BYTE[text++]
    BYTE[colSptr++] := Color
PUB PrintLn(text)
  Print(text)
  CursorX := 0
  NextLine
  i_SetBlinking(true)
  
PUB NextLine
  if(CursorY == 23)
'    CursorY := LastRow  
    i_ScrollOneRowDown
  else
    CursorY++
  CursorX := 0
  md1.MoveCursor0(CursorX, CursorY)
PUB Prompt(promptText) : buffer
  if(CursorX > 0)
    NextLine
  Print(promptText)
  return Input    
PUB PromptWithBuffer(promptText, buffer, capacity) 
  if(CursorX > 0)
    NextLine
  Print(promptText)
  InputWithBuffer(buffer, capacity)
PUB WaitAnykeyPrompt(promptText)
  Print(PromptText)
  Print(string(" [ANYKEY]"))
  kbd.newKey
PUB YesNoPrompt(promptText) : wasYes|  key
  Print(promptText)
  Print(string(" [y/n]?"))
  repeat
    key := kbd.newKey
    if(key == 89 or key == 121)
      return true
    if(key == 78 or key == 110)
      return false   
PUB InputWithBuffer(buffer, capacity) | dispSptr, bufSptr, key, maxn, acceptNew, start
  ''Gets user input from the keyboard.

  dispSptr := CursorY + FirstRow
  if(dispSptr > 23)
    dispSptr -= 24
  dispSptr*=36
  dispSptr += TxtBufferSPTR + CursorX

  maxn := capacity

  acceptNew := true
  bufSptr := buffer
  BYTE[bufSptr] := 0
  
  repeat 
    key := kbd.newKey
    if(key==$0D) 'Enter
      quit                
    if(key==$C8 AND bufSptr > buffer) 'Backspace
      if(CursorX>0) 'If not, cursor is already on last character  
        CursorX--
      else
        CursorX := 35
        CursorY--
      maxn++                      
      acceptNew := true
      i_SetBlinking(true)
      MoveCursor(CursorX,CursorY)
      BYTE[--bufSptr] := 0
      BYTE[--dispSptr] := 32 'Space
            
      
    key := i_TranslateKey(key)

    if(key == 0 OR !acceptNew)
      next

    'Insert character      
    BYTE[bufSptr++] := key
    BYTE[bufSptr] := 0 'Zero-terminate
    BYTE[dispSptr++]:=key
    if(dispSptr > TxtBufferSptr + constant(36*24-1))
      dispSptr -= constant(36*24)
    maxn--
    if(maxn == 0)
      acceptNew := false
      i_SetBlinking(false)
    if(CursorX < 35)
      CursorX++    
      MoveCursor(CursorX,CursorY)
    else
      NextLine
    '  acceptNew := false
     ' i_SetBlinking(false)
      

  NextLine
PUB Input : buffer | dispSptr, bufSptr, key, maxn, acceptNew, start
  InputWithBuffer(@InputBuffer, 36)  
  return @InputBuffer
PUB ParseInt(str) : int | sptr, char, mode
  ''Parses an int: from either DEC, BIN or HEX representation.
  ''Stops parsing on first space.
  ''dec - only digits
  ''bin - % followed by digits
  ''hex - $ or 0x followed by hex digits
  mode := 10
  repeat
    char := BYTE[str++]
    if(char == 120 or char == 88 or char == 36) 'X or x or $
      mode := 16
      int := 0
      next      
    if(char == 37)
      mode := 2
      int := 0
      next
    if(char > 47 and char < 58) 'dec digit
      if(mode == 2)
        abort -1
      int *= mode
      int += char-48
      next
    if(char > 96) 'lowercase
      char -= 32
    if(char > 64 and char < 71) 'A...F
      if(mode <> 16)
        abort -1
      int <<=4 '*= mode
      int += char-55
      next
    if(char == 32 or char == 0)
      return
    abort -1 'Unknown char
      
      
                   
      
    
  
  

          
PRI i_TranslateKey(key) : ascii
  if(31 < key and 127 > key)
    return key
  return 0     
PUB PrintDivider
  if(CursorX > 0)
    NextLine
  PrintLn(string(8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8))
PUB PrintDivider2
  if(CursorX > 0)
    NextLine
  PrintLn(string(7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7))