{               

  JAM_run_md1

  VERSION 01.00

  SCREEN MODE 1
  36 COLUMNS 24 ROWS
  8x6 FONT, NOT ROM FONT
  16 COLOR PALETTE.
  2 CURSORS WITH 3 MODES AND OPTIONAL BLINKING.
  USES 1 COG

  CONFIGURATION RECORD:
  (Passed in MODE PARAM)

  BYTE    | FIELD
  OFFFSET | DESCRIPTION
  ----------------------------------
          |
        0 | TEXT BUFFER SPTR [WORD]
          | SPTR TO 36*24*1BYTE
          | BUFFER. NORMAL CHAR
          | ORDER.
          |
        2 | COLOR BUFFER SPTR [WORD]
          | SPTR TO 36*24*1BYTE
          | BUFFER. 4-BIT COLOR
          | INDEXES. BG MOST SIG-
          | NIFICANT, FG LESS SIGN-
          | NIFICANT
          |
        4 | FONT SPTR [WORD]
          | SPTR TO CHARACTER 0 OF A
          | 6x8 FONT, IN WHICH CHARS
          | ARE MONOCHROMATIC, RIGHT-
          | JUSTIFIED AND EACH CHAR
          | TAKES 8 BYTES WHILE ONE
          | LINE TAKES 1 BYTE. 2MSbs
          | _MUST_ BE ZERO! 
          |
        6 | PALETTE SPTR [WORD]
          | SPTR TO A 16-BYTE, 16-COLOR
          | PALETTE.
          |
        8 | 1ST ROW INDEX [BYTE, 0..23]
          | INDEX OF THE UPPREMOST ROW IN
          | TEXT BUFFER. USED FOR HORIZONTAL
          | SCROLLING. (WHEN END OF BUFFER
          | IS REACHED, READING STARTS AT 0)
          |
        9 | CURSOR 0 CONTROL [BYTE]
          | 0=>CURSOR OFF
          | BIT 7: BLINKING 1=>ON 0=>OFF
          | BITS 0...2:
          | 001: VERTICAL CARET (|)
          | 010,
          | 011: BLOCK
          | 100: HORIZONTAL CARET (_)
          |
       10 | CURSOR 0 X [BYTE,0...35]
          | X IN CHAR COORDINATES.
          |
       11 | CURSOR 0 Y [BYTE, 0...23]
          | Y IN CHAR COORDINATES
          | CURSOR DOES NOT SCROLL
          | WITH TEXT!
          |
       12 | CURSOR 1 CONTROL [BYTE]
          | SEE CURSOR 0 
          |
       13 | CURSOR 1 X [BYTE]
          | SEE CURSOR 0 
          |
       14 | CURSOR 1 Y [BYTE]
          | SEE CURSOR 0 
        
    
   
}
CON

'Horiz. res including overscans
PHYS_H_RES = 240
ACTIVE_PULSES = 180*16
PULSES_1PX = ACTIVE_PULSES / PHYS_H_RES
PULSES_12PX = (ACTIVE_PULSES * 12) / PHYS_H_RES
OBJ
  font: "JAM_run_font_005"
VAR
'  word TXT[36*24/2]
'  word COL[36*24/2]
PUB SetFirstRow(n)
  m_conf_1st_row := n
PUB GetFirstRow(n) : row
  return m_conf_1st_row
PUB MoveCursor0(x,y)
  m_conf_cur_0_x := x
  m_conf_cur_0_y := y
PUB MoveCursor1(x,y)
  m_conf_cur_1_x := x
  m_conf_cur_1_y := y
PUB ConfigureCursor0(conf)
  m_conf_cur_0_ctrl := conf
PUB ConfigureCursor1(conf)
  m_conf_cur_1_ctrl := conf
PUB GetModePar : Param

  return @m_conf
PUB InitMode | x, y
  m_conf_txt_sptr := @TXT
  m_conf_col_sptr := @COL
  m_conf_fnt_sptr := font.GetFontSPTR
  m_conf_pal_sptr := @m_s_palette

  m_conf_1st_row := 0
  
  m_conf_cur_0_ctrl := 0'1+128
  m_conf_cur_0_x := 1
  m_conf_cur_0_y := 1

  m_conf_cur_1_ctrl := 0'2+128
  m_conf_cur_1_x := 2
  m_conf_cur_1_y := 1
  
  repeat y from 0 to 23  
    repeat x from 0 to 35
     TXT.BYTE[(y*36)+x] := 32
     COL.BYTE[(y*36)+x] := $05 '(y&%1111) | (x&%1111)<<4 '$9A 'x+y<<4
                                   
PUB GetModeSPTR : ModeSPTR
  InitMode
  ''Gets SPTR to MODE's LOAD header
  return @m_hdr
PUB GetTxt : sptr
  return @TXT
PUB GetCol : sptr
  return @COL
PUB GetPal : sptr
  return @m_s_palette  
DAT
'///TXT
TXT
              byte 0[36*24]
COL
              byte 0[36*24]              
'///16-COLOR PALETTE
m_s_palette
              byte %0000_0_010
              byte %0000_0_011
              byte %0000_0_100
              byte %0000_0_101
              byte %0000_0_110
              byte %0000_0_111

              byte %0000_1_101
              byte %0110_1_101
              byte %0100_1_101
              byte %0110_1_101
              byte %1000_1_101
              byte %1010_1_101
              byte %1100_1_101
              byte %1110_1_101

              byte %0000_0_111
              byte %0000_0_111
                        
              
              

'///MODE 1 CONFIGURATION
m_conf
m_conf_txt_sptr word 0
m_conf_col_sptr word 0
m_conf_fnt_sptr word 0
m_conf_pal_sptr word 0

m_conf_1st_row byte 0

m_conf_cur_0_ctrl byte 0
m_conf_cur_0_x byte 0
m_conf_cur_0_y byte 0

m_conf_cur_1_ctrl byte 0
m_conf_cur_1_x byte 0
m_conf_cur_1_y byte 0


m_conf_pad    byte 0
'm_conf_pad      word 0


'///MODE 1 ASM CODE
m_hdr
m_len         long m_end-m_begin
m_org         long m_begin

org 96
m_begin
'/////////////////////////
'/////////////////////////
'///ENTRY POINT
'/////////////////////////
'/////////////////////////
              call #m_gen_lut
'ETERNAL MAIN LOOP
'EACH CYCLE DOES ONE FRAME
m_mainlp
              'RELOAD CONF AND SEE IF
              'MODE HAS TO BE CHANGED
              call #c_ld_conf
              'RELOAD MODE CONF
              call #m_rd_conf
              'COPY PALETTE TO COG MEMORY
              call #m_rd_pal

              'DO VSYNC
              call #c_vs_h 'PreEQ
              call #c_vs_l 'Serr
              call #c_vs_h 'PostEQ

              'DO VERTICAL UPPER OVERSCAN
              call #m_v_osc

              mov m_scl_max, m_c_1st_row
              shl m_scl_max, #3
              mov m_scl_ctr, m_scl_max
              'PREPARE SCANLINE LOOP
              
'              mov m_scl_ctr, #0
              
              'SCANLINE LOOP - LOOP ONCE FOR EACH SCL
m_scl_lp              


              'GENERATE SPTR TO CURRENT FONT LINE
              mov m_fnt_ln_sptr, m_scl_ctr
              and m_fnt_ln_sptr, #%111
              add m_fnt_ln_sptr, m_c_fnt_sptr

              'PROCESS CURSORS
              call #m_prc_cur
              'DO HSYNC
              call #c_hsync
              

              

              'DO SCL SPECIFIC TASK & INCREMENT SCLCTR
              movs m_jmptask, #m_tasklist
              mov r0, m_scl_ctr
              and r0, #%111
              add m_jmptask, r0

              nop
              '  Jump to task
m_jmptask     jmp 0-0       
m_task_ret    '  All tasks will jump here when done.

              'LEFT HORIZONTAL OVERSCAN
              mov vscl, m_vscl_l_osc
              waitvid c_col_black, #0

              'PREPARE CHAR LOOP
              '  Each loop poops out 2 chars                
              mov r0, #18        

              mov m_x, #0

              movs m_char_lp_rd, #m_charbuf

              'EVEN SCL: PROCESS COLOR BUFFER 1, READ BUFFER 0
              'ODD SCL: PROCESS 0, READ 1
              test m_scl_ctr, #%1000 wz
        if_z  movd m_waitvid, #m_colbuf_0
        if_nz movd m_waitvid, #m_colbuf_1


              'SET CHARACTER LOOP VSCL
              '  Video scale so that each
              '  waitvid writes 12 pixels              
              mov vscl, m_vscl_12px

                       
              'CHAR LOOP - REAL RASTERIZING!        
m_char_lp
              'Read in 2 next character codes
m_char_lp_rd  mov r1, 0-0
              'R1 = Leftmost char,
              'R2 = Rightmost
              mov r2, r1
              shr r2, #8
              and r1, #255

              shl r1, #3'*8 (Font height)
              add r1, m_fnt_ln_sptr
              'Read pixels from FONT
              rdbyte r1, r1

              shl r2, #3
              add r2, m_fnt_ln_sptr
               'Read pixels from FONT
              rdbyte r2, r2

              add m_lut_rd_r, r2
              add m_lut_rd_l, r1

              'Read line from LUT
m_lut_rd_r    or m_pixels, 0-0
              shl m_pixels, #12
              'Read line from LUT
m_lut_rd_l    or m_pixels, 0-0
              'Apply cursors
              cmp m_x, m_cur0_x wz
        if_e  xor m_pixels, m_cur0_xormask

              cmp m_x, m_cur1_x wz
        if_e  xor m_pixels, m_cur1_xormask
              
m_waitvid     waitvid 0-0, m_pixels


              'Reset cursor stuff     
'              mov m_char_xormask, #0
              add m_x, #1
              

              '  Reset ptrs for next loop
              movs m_lut_rd_r, #m_dec_lut
              movs m_lut_rd_l, #m_dec_lut
              '  Prepare color register for next loop        
              mov m_pixels, m_right_px
              '  Advance color CPTR
              add m_waitvid, m_dst_1
              '  Advance char pointer
              add m_char_lp_rd, #1

              '  Next 2 chars?
              djnz r0, #m_char_lp

              'RIGHT HORIZONTAL OVERSCAN
              mov vscl, m_vscl_r_osc
              waitvid c_col_black, #0

             ' Increment SCL counter
              add m_scl_ctr, #1

              'NEXT SCANLINE?
              cmp m_scl_ctr, #192 wz
       if_z   mov m_scl_ctr, #0  
              cmp m_scl_ctr, m_scl_max wz
        if_nz jmp #m_scl_lp

              'DO VERTICAL LOWER OVERSCAN
              call #m_v_osc

              'NEXT FRAME
              jmp #m_mainlp
                            
'/////////////////////////
'/////////////////////////
'////FUNCTIONS
'/////////////////////////
'/////////////////////////
'///FUNCTION: PROCESS CURSOR (CALLED EACH SCL)
m_prc_cur
              'R3 = Y in char coords
              mov r3, m_scl_ctr
              shr r3, #3

              mov r0, m_c_cur0_ctrl
              mov r1, m_c_cur0_x
              mov r2, m_c_cur0_y
              'Cursors don't scroll with txt
              add r2, m_c_1st_row
              cmpsub r2, #24
               
              call #m_prc_cur_md
              mov m_cur0_x, r1
              mov m_cur0_xormask, r2
                                   
              mov r0, m_c_cur1_ctrl
              mov r1, m_c_cur1_x
              mov r2, m_c_cur1_y
              'Cursors don't scroll with txt
              add r2, m_c_1st_row
              cmpsub r2, #24

              call #m_prc_cur_md
              mov m_cur1_x, r1
              mov m_cur1_xormask, r2
              
m_prc_cur_ret ret

m_prc_cur_md

               'If blinking and blinked off, don't process
              test r0, #%10000000 wz
        if_nz test m_blink_cntmask, cnt wz
        if_z  cmp r3, r2 wz
              mov r2, #0 wc              
        if_nz jmp m_prc_cur_md_ret
              cmp r0, #0 wz
        if_z  jmp m_prc_cur_md_ret

              'Do mode-specific processing
              'If mode=0, will return directly
 '             and r0, #%01111111
 '             movs m_prc_mdprc, #m_cur_md_tbl-1
 '             add m_prc_mdprc, r0
 '             mov r0, #0
'm_prc_mdprc   jmp 0-0

              test r0, #%011 wz
'm_cur_md2     'HORIZONTAL CARET (UNDERSCORE)
     if_z     test m_scl_ctr, #%110 wc, wz
if_c_or_z     jmp m_prc_cur_md_ret

              test r0, #%110 wz
'm_cur_md1     'BLOCK CURSOR
   if_nz      mov r2, m_l_xormask
'm_cur_md3     'VERTICAL CARET
              or r2, #1

              shr r1, #1 wc
        if_c  shl r2, #12
'              jmp m_prc_cur_md_ret

m_prc_cur_md_ret ret
              

              'After calling a function in this table:
              'R1 = X when to apply cursor
              'R0 = XORMASK
{m_cur_md_tbl  long m_cur_md1
              long m_cur_md2
              long m_cur_md3
                        }

'///FUNCTION: READ MODE CONFIGURATION
m_rd_conf     mov r1, c_md_par
              movd :m_rd_conf_word_lp, #m_conf_begin
              movd m_rd_bytes, #m_conf_begin+4
              'Loop one for each WORD in CONF
              mov r0, #4
:m_rd_conf_word_lp
              rdword 0-0, r1
              add :m_rd_conf_word_lp, m_dst_1
              add r1, #2              
              djnz r0, #:m_rd_conf_word_lp

              mov r0, #7              
              call #m_rd_bytes
m_rd_conf_ret ret
'///FUNCTION: READS THE 16 COLOR PALETTE FROM MEM
m_rd_pal
              mov r1, m_c_pal_sptr
              movd m_rd_bytes, #m_palette

              mov r0, #16
:m_rd_pal_lp
              call #m_rd_bytes

m_rd_pal_ret  ret

m_rd_bytes
              rdbyte 0-0, r1
              add m_rd_bytes, m_dst_1
              add r1, #1
              djnz r0, #m_rd_bytes
m_rd_bytes_ret ret 


'///FUNCTION: DO VERT. OVERSCAN. 26 SCANLINES. (244-26*2 = 192)
m_v_osc
              mov r0, #26 
:m_v_osc_lp
              call #c_empty_scl
              djnz r0, #:m_v_osc_lp

m_v_osc_ret   ret

'///FUNCTION: CALCULATES OFFSET OF CURRENT ROW
'             IN BYTES (FOR TEXT AND COLOR BUFFER)
m_calc_row_offset
              'R0=CHAR Y * 4
              mov r0, m_scl_ctr
              andn r0, #%111
              mov r1, r0         
              shr r0,#1
              'R1=CHAR Y * 32
              shl r1, #2
              'R1 = CHAR Y * 36
              'ie. LINE's BYTE OFFSET
              add r1, r0
m_calc_row_offset_ret ret



'///TASK: DO NOTHING
m_nulltask    jmp #m_task_ret


'///TASK: READS CHAR CODES FOR CURRENT SCANLINE
m_rd_chars
              call #m_calc_row_offset
              add r1, m_c_txt_sptr
              'Loop: one cycle gets 4 characters
              movd m_rd_stuff_0, #m_charbuf
              movd m_rd_stuff_1, #m_charbuf+1

              jmp #m_rd_stuff

'///TASK: READS COLOR CODES (PALETTE INDEXES)
'              FOR NEXT SCANLINE               
m_rd_cols
              call #m_calc_row_offset
              add r1, #36 'NEXT LINE!

              cmp m_scl_ctr, #192-8 wz, wc
   if_nc_or_z mov r1, #0
   
              add r1, m_c_col_sptr
                                                
              test m_scl_ctr, #%1000 wz
              'Even row->write to buffer 1
        if_z  movd m_rd_stuff_0, #m_colbuf_1
        if_z  movd m_rd_stuff_1, #m_colbuf_1+1
              'Odd row->write to buffer 0
        if_nz movd m_rd_stuff_0, #m_colbuf_0
        if_nz movd m_rd_stuff_1, #m_colbuf_0+1
              
              jmp #m_rd_stuff

'SHARED PART OF M_RD_CHARS AND M_RD_COLS
m_rd_stuff
              mov r0, #9
m_rd_stuff_lp
m_rd_stuff_0  rdword 0-0, r1
              add m_rd_stuff_0, m_dst_2
              add r1, #2
              
m_rd_stuff_1  rdword 0-0, r1 
              add m_rd_stuff_1, m_dst_2
              add r1, #2               
              djnz r0, #m_rd_stuff_lp

              jmp #m_task_ret

              
'///TASK:     PROCESSES 1/4 OF COLORS
m_prc_cols
              test m_scl_ctr, #%1000 wz
              'Evem row - process buffer 1
        if_z  movs m_prc_rd, #m_colbuf_1
        if_z  movd m_prc_wr, #m_colbuf_1
              'Odd row - process buffer 0
        if_nz movs m_prc_rd, #m_colbuf_0
        if_nz movd m_prc_wr, #m_colbuf_0
        
              test m_scl_ctr, #%001 wz
        if_z  add m_prc_rd, #9
        if_z  add m_prc_wr, m_dst_9
        

              mov r0,  #9

m_prc_lp
m_prc_rd      mov r1, 0-0
              add m_prc_rd, #1

              test r1, m_high_word wz

              mov r2, r1
              and r2, #%1111
              movs m_prc_palrd_0, #m_palette
              add m_prc_palrd_0, r2

              mov r2, r1
              shr r2, #4
              and r2, #%1111

              movs m_prc_palrd_1, #m_palette
              add m_prc_palrd_1, r2              
              
              shr r1, #8

m_prc_palrd_0 mov r3, 0-0'm_palette+15'0-0'#%0000_0_010'0-0
              shl r3, #8
m_prc_palrd_1 or r3, 0-0'm_palette'10-0'#%0000_0_110'0-0
              shl r3, #16

              'Is this second processing
              'on the same data?              
              'If so, the middle bytes are
              'processed colors.
        if_nz shr r1, #8
                
'              mov r3, m_test_col_half
              or r1, r3

              
m_prc_wr      mov 0-0, r1
              add m_prc_wr, m_dst_1
              djnz r0, #m_prc_lp

              jmp #m_task_ret


'/////////////////////////
'/////////////////////////
'///INITIALIZED CONSTANTS
'/////////////////////////
'/////////////////////////

m_dst_1       long      1<<9
m_dst_2       long      2<<9
m_dst_9       long      9<<9
m_high_word   long      %11111111_11111111_00000000_00000000
m_all_one     long      %11111111_11111111_11111111_11111111

m_vscl_12px   long      ((PULSES_12PX / 12) << 12) | PULSES_12PX  
m_vscl_l_osc  long      PULSES_1PX << 12 | (PULSES_1PX*8)' + (47*2)
m_vscl_r_osc  long      PULSES_1PX << 12 | (PULSES_1PX*16)


m_blink_cntmask long %10_0000000_0000000_0000000_000

        'Pixel value added to left characters
m_right_px     long      %%222222


m_l_xormask   long %%111111
'm_test_col    long      %0000_0_110__0000_0_010__0000_0_110__0000_0_010

'm_test_px     long      %%010101010101
'///TASKLIST:
'First task (task 0) is done
'on first scanline of each char and so on...
m_tasklist
m_task_0      long      m_rd_chars              'SCL 000
m_task_1      long      m_rd_cols               'SCL 001
m_task_2      long      m_prc_cols              'SCL 010
m_task_3      long      m_prc_cols              'SCL 011
m_task_4      long      m_prc_cols              'SCL 100
m_task_5      long      m_prc_cols              'SCL 101
m_task_6      long      m_nulltask              'SCL 110
m_task_7      long      m_nulltask              'SCL 111

m_col_default long %%0101

'/////////////////////////
'/////////////////////////
'///UNINITIALIZED DATA
'/////////////////////////
'/////////////////////////



'------------------------
'GENERAL-PURPOSE REGS
r0            long 1
r1            long 1
r2            long 1
r3            long 1


'r4            res 1

'------------------------
'SPECIFIC TEMP REGS
m_pixels      res 1

m_cur0_x      res 1
m_cur1_x      res 1
m_cur0_xormask res 1
m_cur1_xormask res 1

m_x           res 1

'------------------------
'MISC VARS
        'Scanline counter. Count active
        'scanlines from 0 to 191.
m_scl_ctr     res 1
        'Pointer to font + Y offset
m_fnt_ln_sptr res 1

m_scl_max     res 1



'------------------------
'CONFIG:
m_conf_begin
m_c_txt_sptr  res 1
m_c_col_sptr  res 1     
m_c_fnt_sptr  res 1
m_c_pal_sptr  res 1
m_c_1st_row   res 1
m_c_cur0_ctrl res 1
m_c_cur0_x    res 1
m_c_cur0_y    res 1             
m_c_cur1_ctrl res 1
m_c_cur1_x    res 1
m_c_cur1_y    res 1             

              
m_end
              'Character buffer for scanline
              '(2 char codes per long)
m_charbuf
              res 18
              'Pixel-decoding LUT
m_dec_lut
              res 64

              '16-color Palette
m_palette
              res 16
              
              'Color buffer 0
              '(2 colors for 2 chars in 1 long)
m_colbuf_0
              res 18
              'Color buffer 1
              '(2 colors for 2 chars in 1 long)
m_colbuf_1
              res 18
              
              'Reserve space for the LOADER
              res 20

'This is after data defined w/ LONGs, not RESs.
org m_pixels                 

'///FUNCTION: GENERATES THE LOOKUP TABLE TO DECODE
'             FONT PIXELS INTO SCREEN PIXELS
m_gen_lut
              'LOOP FOR EACH CODE
              '64 LUT codes (6-bit wide chars)              
              mov r0, #0
              movd :m_gen_lut_wr, #m_dec_lut
:m_gen_lut_cdlp
              mov r3, #0
              mov r1, #1
              'LOOP FOR EACH INPUT BIT
              mov r2, #6
:m_gen_lut_bitlp
              shl r3, #2                    
              test r0, r1 wz
        if_nz add r3, #1
              shl r1, #1

              djnz r2, #:m_gen_lut_bitlp

:m_gen_lut_wr
              mov 0-0, r3
              add :m_gen_lut_wr, m_dst_1 
              'NEXT LUT CODE

              add r0, #1
              cmp r0, #64 wz
        if_nz jmp #:m_gen_lut_cdlp             

m_gen_lut_ret ret             




'/////////////////////////
'/////////////////////////
'///RAST INTERFACE
'/////////////////////////
'/////////////////////////
org $010
c_ld_conf 'Reloads DRIVER CONF and switches mode if must.
org $019
c_ld_conf_ret
org $022
c_vs_h 'Does a high VSYNC (EQUALIZING LINES)
org $028
c_vs_h_ret
org $029
c_vs_l  'Does a low VSYNC (SERRATION PULSES)
org $030
c_vs_l_ret
org $031
c_empty_scl 'Does one black scl. HSYNC included.
org $035
c_empty_scl_ret
org $036
c_hsync
org $038
c_hsync_ret
org $045
c_col_black 'Holds black colors (Use this for OVERSCAN)
org $04A
c_md_par