{                               

  JAM_run_rast2

  VERSION 010


  RASTERIZER INTERFACE FOR
  SCREEN MODES (COPY THE FOLLOWING
  IN THE END OF MODE ASM)
  
org $008
c_ld_conf 'Reloads DRIVER CONF and switches mode if must.
org $011
c_ld_conf_ret
org $01A
c_vs_h 'Does a high VSYNC (EQUALIZING LINES)
org $020
c_vs_h_ret
org $021
c_vs_l  'Does a low VSYNC (SERRATION PULSES)
org $028
c_vs_l_ret                                           
org $029
c_empty_scl 'Does one black scl. HSYNC included.
org $02D
c_empty_scl_ret
org $02E
c_hsync  'Does a HSYNC and changes status (FUTURE FEATURE, NOT IMPL.)
org $030
c_hsync_ret
org $03D
c_col_black 'Holds black colors (Use this for OVERSCAN)
org $042
c_md_par
  
}
OBJ
ldr : "JAM_run_load_010"
fnt : "JAM_run_font_005"

'DEFAULT SCREEN MODES
'Null mode (No output)
'md0 : "JAM_run_mdnull"
  'Mode 1 (Std text mode)
md1 : "JAM_run_md1_005"

CON
  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000

  'CTRA pulses each scanline, sync
  'included
  SCL_PULSES = 227*16
  'CTRA pulses per HSYNC
  HBLK_PULSES = 47*16
  'CTRA pulses each scanline, only
  'active px data, ie. sync not
  'included.
  ACTIVE_PULSES = SCL_PULSES - HBLK_PULSES

  'Count of pulses to output n pixels
{  PIX_PULSES_X16 = ( ACTIVE_PULSES *16 ) / H_PHYS_RESOLUTION 
  PIX_PULSES_X12 = ( ACTIVE_PULSES * 12 ) / H_PHYS_RESOLUTION 
  PIX_PULSES_X8 = ( ACTIVE_PULSES * 8 ) / H_PHYS_RESOLUTION 
  PIX_PULSES_X4 = (ACTIVE_PULSES * 4) / H_PHYS_RESOLUTION
 }
  MODE_ORG = 96 

  'STATUS WORD:
  'LSB: STATUS BITS
  STATUS_READY = %001
  STATUS_VBLNK = %010
  STATUS_HBLNK = %100

  MAX_MODES = 2
  
VAR
'long Modelist[16]
'long ModeCtr
PUB TestDrv
  Start(24)
  SetMode(1, md1.GetModePar)
'  ras_md_par := md1.GetModePar
'  if((md1.GetModePar & %11) <> 0)
'    outa:=1
 '   dira:=1
    
'  if((@ras_ctrl & %11) <> 0)
'    outa:=1
'    dira:=1
  repeat
PRI InitModes
  ModeCtr := 0
  'Modes added here
  RegisterMode(md1.GetModeSPTR)

PUB RegisterMode(ModeSPTR) : ModeID
  if modectr == MAX_MODES
    abort -1
  ''Adds a mode to MODE LIST. Returns inserted
  ''modes ID.
  ras_ModeList[ModeCtr] := ModeSPTR
  ModeID:=ModeCtr
  ModeCtr++
PUB Start(basepin)              
  InitModes

'SET LDR TO LOAD CODE COMMON
'TO EACH RASTERIZER DRIVER
  asm0 := @common_ldr_hdr

'INITIALIZE RASTERIZER CTRL
'STRUCT
  ras_ml_sptr := @ras_Modelist
  'Start in NULL mode (Only blink DBGLED)
  ras_md_idx := 0


  ras_outpins := (%1111 << basepin)  
'Following stolen from TV_text
'  ras_tvpins := (basepin & $38) << 1 | (basepin & 4 == 4) & %0101
  ras_tvpins := ((basepin >> 3) << 9) + (%0111 << (basepin & 4))
'TELL RASTERIZER WHERE CONTROL
'STRUCT IS IN SHARED RAM
  param := @ras_ctrl

  ldr.StartCog(@ras_ldr_hdr)

PUB SetMode(ModeIDX, ModePARAM)
  ras_md_idx := ModeIDX
  ras_md_par := ModePARAM
DAT


'Control struct for the
'rasterizer
ras_ctrl
ras_ml_sptr   long 0
ras_md_idx    long 0
ras_md_par    long 0
ras_status    long 0
'VGEN vonf
ras_tvpins    long 0
'DIRACONF
ras_outpins   long 0

ras_modelist  long 0[MAX_MODES]
modectr       long 0


'Multi-ASM header
ras_ldr_hdr
num_asms      long 1
asm0          long 0
param         long 0


common_ldr_hdr
c_len         long common_end-common_begin   
c_org         long common_begin
org 0
'Code common to each rasterizer
common_begin
'/////////////////////////
'/////////////////////////
'///ENTRY POINT - INITIALIZATION
'/////////////////////////
'/////////////////////////

              'DBGLED AND VIDEO as output
'              or dira, c_output_mask

'///INITIALIZE VIDEO HW
              
        'SELECT OUTPUT PINS
              'Pinmask Select the 3 DAC pins


              mov r0, JAM_ldr_param
              add r0, #16
              rdlong r1, r0
              mov vcfg, r1
              add r0, #4
              rdlong r1, r0
              or r1, #1
              or dira, r1

'              or outa, #1
'              movs    vcfg, #%0000_0111
              'Select pingroup 3 (Pins 24....31)
 '             movd    vcfg, #3
        'CONFIGURE VSU                            
              'baseband video on bottom nibble, 2-bit color,
              'enable chroma on broadcast & baseband                              
              'First 2 bits (From left): 10 => Composite baseband on bottom nibble
              '3rd: 1=> 4 color mode
              '4th: 1=>Chroma on broadcast
              '5th: 1=>Chroma on baseband (composite)
              'Next 3: Unused (Aural cog selection)
              movi    vcfg, #%010111__000
        'INIT CTRA
              'Set counter mode:      0001 means Internal, routed to video hardware
              '                       111 means PLLx16 (PLL is driven
              '                         from the MSB [Most Significant Bit] of phsa)               
              movi    ctra, #%0001_111
              'Set counter frequency so that
              'it will output colorburst frequency
              'multiplied by 16 by PLL
              mov     frqa, c_ctra_frq
              mov     phsa, #0
              
'///READ CONFIG AND ENTER A VIDEO MODE
              jmp #c_ld_conf
'              jmp #c_ld_md
              long 0,0,0
              j



              
'/////////////////////////
'/////////////////////////
'///MODE/CONF FUNCTIONS
'/////////////////////////
'/////////////////////////

org $010
'///FUNCTION: (RE)LOADS CONFIGURATION. SWAPS MODE IF NECESSARY. 
c_ld_conf
              'Read MODE LIST pointer.
              mov r0, JAM_ldr_param
              rdlong c_conf_ml_sptr, r0
              
              'Read MODE INDEX and see if it has changed
              add r0, #4
              rdlong r1, r0
              cmp r1, c_conf_md_idx wz
              mov c_conf_md_idx, r1

              'Read in MODE PARAM
              add r0, #4
              rdlong c_conf_md_par, r0

              'If MODE INDEX changed, switch mode.
        if_nz jmp #c_ld_md             
              
c_ld_conf_ret  ret
'///FUNCTION: (RE)LOADS MODE AND ENTERS IT. NEVER RETURNS.
c_ld_md

              'R0 = LONG offset to modelist
              mov r0, c_conf_md_idx
              shl r0, #2 '*4
              'R0=SPTR to MODE SPTR
              add r0, c_conf_ml_sptr
              'R0 = MODE SPTR
              rdlong r0, r0

              'Load MODE using JAM_LOAD
              '(MODE SPTR is SPTR to mode's
              'LDR header)
              mov JAM_ldr_asmptr, r0
              mov JAM_ldr_nsections, #1 'Load only 1 file
              jmpret JAM_ldr_ret, #JAM_ldr_loadone


              jmp #MODE_ORG


'/////////////////////////
'/////////////////////////
'///VIDEO HELPER FUNCTIONS
'/////////////////////////
'/////////////////////////


'///FUNCTION: DOES A HIGH VSYNC (PRE/POST EQ)
c_vs_h
              'LOOP 6 LINES
              mov r0, #6
:c_vs_h_lp
              mov vscl, c_sync_scale
              waitvid c_sync_colors, c_vsc_h_px_0

              mov vscl, c_blk_scl_scale
              waitvid c_sync_colors, c_vsc_h_px_1
                            
              djnz r0, #:c_vs_h_lp              

c_vs_h_ret    ret

'///FUNCTION: DOES A LOW VSYNC (SERRATION PULSES)
c_vs_l
              'LOOP 6 LINES
              mov r0, #6
:c_vs_l_lp
              mov vscl, c_sync_scale
              waitvid c_sync_colors, c_vsc_l_px_0
              waitvid c_sync_colors, c_vsc_l_px_1

              mov vscl, c_vs_l_scale
              waitvid c_sync_colors, c_vsc_l_px_2       
              
              djnz r0, #:c_vs_l_lp
c_vs_l_ret    ret
'///FUNCTION: DOES ONE EMPTY SCANLINE. DOES NOT AFFECT SCANLINE CTR.
c_empty_scl
              mov vscl, c_sync_scale         
              waitvid c_sync_colors, c_hsc_px              
              mov vscl, c_blk_scl_scale
              waitvid c_col_black, #0
c_empty_scl_ret ret
'///FUNCTION: DOES HSYNC AND UPDATES STATUS (IN FUTURE)
c_hsync
              mov vscl, c_sync_scale         
              waitvid c_sync_colors, c_hsc_px              
c_hsync_ret   ret
'/////////////////////////
'/////////////////////////
'///INITIALIZED CONSTANTS!
'/////////////////////////
'/////////////////////////

'------------------------
'MISC CONSTANTS


        'PORTA MASK FOR TV PINS AND DBG LED
c_output_mask             long    %0000_0111<<24 + 1
        'INCREMENT OF PHSA TO OBTAIN A MULTIPLE
        'OF THE COLORBURST FRQ
c_ctra_frq                long    192_175_359


'------------------------
'PIXEL DATA


        'HIGH VSYNC COLORS (PRE/POST EQ)
c_vsc_h_px_0            long    %%1_1_1_1_1_1_1_2_2_2_2_2_2_2_1_1  
c_vsc_h_px_1            long    %%1_1_1_1_1_1_1_1_1_1_1_1_1_1_1_1
        'LOW VSYNC COLORS (SERRATION)
c_vsc_l_px_0            long    %%2_2_2_2_2_2_2_2_2_2_2_2_2_2_1_1
c_vsc_l_px_1            long    %%1_1_1_1_2_2_2_2_2_2_2_2_2_2_2_2
c_vsc_l_px_2            long    %%2_2_2_2_2_2_2_2_2_2_2_2_2_2_2_2
        'HSYNC COLORS
c_hsc_px                long     %%1111_000_1_222222_11   'sync_normal


'------------------------
'VIDEO SCALES


        'SCALE USED WITH HSYNC AND VSYNC
c_sync_scale            long    (HBLK_PULSES >> 4) << 12 + HBLK_PULSES '- (47*2))
        'SCALE USED TO DRAW A WHOLE EMPTY SCANLINE
c_blk_scl_scale         long    (ACTIVE_PULSES >> 4) << 12 + ACTIVE_PULSES '+ (47*2)  
        'SCALE USED WHEN DOING SERRATION PULSES
c_vs_l_scale          long    (ACTIVE_PULSES >> 4) << 12 + (ACTIVE_PULSES-HBLK_PULSES) '+ 2 * (47*2)    


'------------------------
'PRESET COLORS

        'COLORS USED WITH HSYNC AND VSYNC: 
c_sync_colors           long $00_00_02_8A                              
c_col_black             long %0000_0_010__0000_0_010__0000_0_010__0000_0_010



'/////////////////////////
'/////////////////////////
'///UNINITIALIZED DATA
'/////////////////////////
'/////////////////////////


'------------------------
'GENERAL PURPOSE REGS


r0                      long 0'res 1
r1                      long 0'res 1

'------------------------
'RASTERIZER CONFIGURATION (SPTR TO PASSED IN JAM_ldr_param)
c_conf_begin
c_conf_ml_sptr          long 1'res 1
c_conf_md_idx           long 189'res 1
c_conf_md_par           long 0 'res 1                                

common_end


        'JAM_load parameter/function addresses
        'See JAM_load_xxx.spin for reference.
        '---
        'Parameter passed to the program on
        'Cog init. Not par register, but an
        'optional parameter passed to the loader.  
        org $1DC
        JAM_ldr_base 'Loader starts here
        JAM_ldr_param
        'Loader parameter (SPTR to
        'loader parameter record). Setting this
        'is same as passing PAR with coginit
        org $1DD
        JAM_ldr_arg
        'Number of ASM sections to load. Used
        'when loading only one file. Ie. don't
        'set this to any value other tan #1. 
        org $1EB
        JAM_ldr_nsections
        'SPTR to ASM section to load. Pointer
        'to header, not the real asm. 
        org $1EC
        JAM_ldr_asmptr
        'Function that loads COG memory map
        'specified by data record pointed by
        'JAM_ldr_par
        org $1DE
        JAM_ldr_load
        'Function that loads one ASM file to
        'Cog memory. JAM_ldr_nsections must be
        'one. JAM_ldr_asmptr must point to ASM
        'section to load. PARAMETER WON'T BE
        'UPDATED!! 
        org $1E1
        JAM_ldr_loadone
        'Address of return line of all the
        'functions. Always the 1st parameter
        'of JMPRET.
        org $1EA
        JAM_ldr_ret
        'These are registers that can ALWAYS
        'be used as general purpose registers
        'when JAM_load is not being used.
        org $1ED
        JAM_ldr_r0
        org $1EC 